package com.sun.jmx.snmp;

import java.util.Date;
import java.io.Serializable;

public class Timestamp implements Serializable
{
    private static final long serialVersionUID = -242456119149401823L;
    private long sysUpTime;
    private long crtime;
    private SnmpTimeticks uptimeCache;
    
    public Timestamp() {
        this.uptimeCache = null;
        this.crtime = System.currentTimeMillis();
    }
    
    public Timestamp(long sysUpTime, long crtime) {
        this.uptimeCache = null;
        this.sysUpTime = sysUpTime;
        this.crtime = crtime;
    }
    
    public Timestamp(long sysUpTime) {
        this.uptimeCache = null;
        this.sysUpTime = sysUpTime;
        this.crtime = System.currentTimeMillis();
    }
    
    public final synchronized SnmpTimeticks getTimeTicks() {
        if (this.uptimeCache == null) {
            this.uptimeCache = new SnmpTimeticks((int)this.sysUpTime);
        }
        return this.uptimeCache;
    }
    
    public final long getSysUpTime() {
        return this.sysUpTime;
    }
    
    public final synchronized Date getDate() {
        return new Date(this.crtime);
    }
    
    public final long getDateTime() {
        return this.crtime;
    }
    
    @Override
    public final String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("{SysUpTime = " + SnmpTimeticks.printTimeTicks(this.sysUpTime));
        sb.append("} {Timestamp = " + this.getDate().toString() + "}");
        return sb.toString();
    }
}
